/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.threevoid.trebuchet;

/**
 *
 * @author Max
 */
import com.threevoid.trebuchet.actors.Projectile;
import com.threevoid.trebuchet.actors.Target;
import org.newdawn.slick.BasicGame; 
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics; 
import org.newdawn.slick.SlickException; 
import org.newdawn.slick.AppGameContainer; 
import org.newdawn.slick.Input;
 
public class Applet extends BasicGame 
{ 
  public Applet() 
  { 
    super( "Trebuchet" ); 
  } 
  
  Projectile projectile;
  Target target;
  @Override 
  public void init( GameContainer container ) throws SlickException
  {
      WorldHolder.create();
      projectile = new Projectile();
      projectile.load(); 
      target = new Target();
      target.load();
      WorldHolder.projectile = projectile;
      WorldHolder.target = target;
      
  } 
 
  @Override 
  public void update( GameContainer container, int delta ) throws SlickException
  {
        //delta = time in ms since last update
//      if(!worldRunning) startWorld();
      Input input = container.getInput();
      if(input.isKeyPressed(Input.KEY_W)){
          projectile.jump();
      }
      if(input.isKeyDown(Input.KEY_D)){
          projectile.right(delta);
      }else if(input.isKeyDown(Input.KEY_A)){
          projectile.left(delta);
          
      }
  } 
 
//  private boolean worldRunning = false;
//  private void startWorld(){
//      worldRunning = true;
//      new Thread(new Runnable(){
//            @Override
//            public void run() {
//                while(worldRunning){
//                    WorldHolder.step(1);
//                    try{Thread.sleep(1);}catch(InterruptedException ex){}
//                }
//            }
//          
//      }).start();
//  }
  
  
  @Override 
  public void render( GameContainer container, Graphics g ) throws SlickException 
  { 
    WorldHolder.step();
    WorldHolder.getBoundary().draw(g);
    projectile.draw(g);
    target.draw(g);
    g.drawString( Integer.toString( container.getWidth() ) +
                    "x" +
                    Integer.toString( container.getHeight() ), 
                  10, 
                  25 ); 
  }
 
  public static void main( String[] args ) 
  { 
    try 
    { 
      AppGameContainer app = new AppGameContainer( new Applet() );
      app.setDisplayMode( (int)Math.ceil(WorldHolder.toPixels(WorldHolder.WidthInMetres)), 
              (int)Math.ceil(WorldHolder.toPixels(WorldHolder.HeightInMetres)), false );
        app.setSmoothDeltas(true);
        app.setTargetFrameRate(60);
        app.setShowFPS(true);
      app.start(); 
    } 
    catch ( SlickException e ) 
    { 
      e.printStackTrace(); 
    } 
  } 
}